# All files / core database_info.ts

100% Statements 20/20
100% Branches 7/7
100% Functions 7/7
100% Lines 18/18

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67

    2x

    2x

    618x
    618x
    618x
    618x

    2x

    2x

    2x

    786x
    786x

    2x
    228x

    2x
    350x

    2x
    93x

    2x
     /**
     * Copyright 2017 Google Inc.
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *   http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */

    import { primitiveComparator } from '../util/misc';

    export class DatabaseInfo {
      /**
       * Constructs a DatabaseInfo using the provided host, databaseId and
       * persistenceKey.
       *
       * @param databaseId The database to use.
       * @param persistenceKey A unique identifier for this Firestore's local
       * storage (used in conjunction with the databaseId).
       * @param host The Firestore backend host to connect to.
       * @param ssl Whether to use SSL when connecting.
       */
      constructor(
        readonly databaseId: DatabaseId,
        readonly persistenceKey: string,
        readonly host: string,
        readonly ssl: boolean
      ) {}
    }

    /** The default database name for a project. */
    const DEFAULT_DATABASE_NAME = '(default)';

    /** Represents the database ID a Firestore client is associated with. */
    export class DatabaseId {
      readonly database: string;
      constructor(readonly projectId: string, database?: string) {
        this.database = database ? database : DEFAULT_DATABASE_NAME;
      }

      get isDefaultDatabase(): boolean {
        return this.database === DEFAULT_DATABASE_NAME;
      }

      isEqual(other: {}): boolean {
        return (
          other instanceof DatabaseId &&
          other.projectId === this.projectId &&
          other.database === this.database
        );
      }

      compareTo(other: DatabaseId): number {
        return (
          primitiveComparator(this.projectId, other.projectId) ||
          primitiveComparator(this.database, other.database)
        );
      }
    }